
      program total

      implicit none

      real x,x1,t0,t,u0,u,f
      real e(1000)

      real we(1000),wmu(1000),muw(1000)
      real se(1000),smu(1000),mus(1000)
      integer ne,nw,ns

      real sr,st,pbt,pst,sdist,rho

      character*70 dmat,wmat,cmat,hmat,smat,bmat,airmat,amat

      integer nbul
      integer i,j,n

      ne=1
      open(7,file='reference.txt',status='old')
11    continue
      read(7,*,end=22) e(ne)
      e(ne)=log(e(ne))
      ne=ne+1
      goto 11
22    continue
      close(7)
      ne=ne-1
      close(7)

      open(7,file='standard.txt',status='old')
      read(7,*) sr
      read(7,*) st
      read(7,*) pbt
      read(7,*) pst
      read(7,*) sdist
      read(7,77) wmat
      read(7,77) bmat
      close(7)
77    format(a)

      open(7,file='sample.txt',status='old')
      read(7,*) sr
      read(7,*) st
      read(7,*) pbt
      read(7,*) pst
      read(7,*) sdist
      read(7,77) smat
      read(7,77) bmat
      close(7)
      
      call readin(wmat,nw,we,wmu,0.)
      call readin(smat,ns,se,smu,0.)

      do j=1,ne
        call inter(nw,we,wmu,e(j),muw(j))
        call inter(ns,se,smu,e(j),mus(j))
      enddo

      open(7,file='model.txt',status='unknown')
      do i=1,ne
        u0=muw(i)*st
        u=mus(i)*st
        t0 = (1-exp(-u0))/u0
        t = (1-exp(-u))/u       
	x = t / t0
	f=u/(exp(u)-1)-1
        write(7,99) exp(e(i)),u0,u,x
	write(*,99) exp(e(i)),u,f
      enddo
      close(7)
99    format(10f15.5)

      end

      subroutine readin(fname,n,e,mu,rho)

      implicit none

      character*(70) fname
      character*(132) line

      integer n
      integer left,right
      integer l,r
      integer kode

      real e(1000),mu(1000)
      real ene,rayl,comp,phot,pair,pair1,tot,tot1
      real den,rho

      l=left(fname)
      r=right(fname)

      open(7,file='.\\Composition\\'//fname(l:r)//'.txt',status='old')
      read(7,*) den
      close(7)

      if (rho.gt.0.) den=rho

      n=1

      open(7,file='.\\Material\\'//fname(l:r)//'.txt',status='old')

1     continue

      read(7,'(a)',end=2) line

      line=line(8:len(line))

      read(line,*,err=1,iostat=kode) 
     +ene,rayl,comp,phot,pair,pair1,tot,tot1

      if (kode.eq.0) then

        ene=ene*1.e3
        rayl=rayl*den
        comp=comp*den
        phot=phot*den
        pair=pair*den
        tot=tot*den
        tot1=tot1*den

        if (rayl.le.0)  rayl=1.e-15
        if (comp.le.0)  comp=1.e-15
        if (phot.le.0)  phot=1.e-15
        if (pair.le.0)  pair=1.e-15
        if (pair1.le.0) pair1=1.e-15
        if (tot.le.0)   tot=1.e-15
        if (tot1.le.0)  tot1=1.e-15

        e(n)=ene

        mu(n)=tot1
        mu(n)=mu(n)/10.

        e(n)=log(e(n))
        mu(n)=log(mu(n))
     
        n=n+1
      
      endif
   
      goto 1

2     continue

      close(7)
      n=n-1

      return
      end

      integer function left(s)
      implicit none
      integer n,l
      character blank
      character*(*) s
      blank=' '
      l=len(s)
      n=1
      do while (s(n:n).eq.blank.and.n.lt.l)
        n=n+1
      enddo
      left=n
      return
      end

      integer function right(s)
      implicit none
      integer n
      character blank
      character*(*) s
      blank=' '
      n=len(s)
      do while (s(n:n).eq.blank.and.n.gt.1)
        n=n-1
      enddo
      right=n
      return
      end

      subroutine inter(n,e,mu,xe,xmu)
      implicit none
      integer n,j
      real e(100),mu(100),xe,xmu
      j=1.
      do while(e(j).lt.xe.and.j.lt.n)
         j=j+1
      enddo
      j=j-1
      if (j.eq.0) j=1
      xmu=(mu(j+1)-mu(j))/(e(j+1)-e(j))*(xe-e(j))+mu(j)
      xmu=exp(xmu)
      return
      end

